> For the complete documentation index, see [llms.txt](https://docs.nats.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nats.io/nats-concepts.md).

# NATS Concepts

- [Overview](https://docs.nats.io/nats-concepts/overview.md)
- [Compare NATS](https://docs.nats.io/nats-concepts/overview/compare-nats.md): NATS Comparison to Kafka, Rabbit, gRPC, and others
- [What is NATS](https://docs.nats.io/nats-concepts/what-is-nats.md)
- [Walkthrough Setup](https://docs.nats.io/nats-concepts/what-is-nats/walkthrough_setup.md)
- [Subject-Based Messaging](https://docs.nats.io/nats-concepts/subjects.md)
- [Core NATS](https://docs.nats.io/nats-concepts/core-nats.md)
- [Publish-Subscribe](https://docs.nats.io/nats-concepts/core-nats/pubsub.md)
- [Pub/Sub Walkthrough](https://docs.nats.io/nats-concepts/core-nats/pubsub/pubsub_walkthrough.md)
- [Request-Reply](https://docs.nats.io/nats-concepts/core-nats/reqreply.md)
- [Request-Reply Walkthrough](https://docs.nats.io/nats-concepts/core-nats/reqreply/reqreply_walkthrough.md)
- [Queue Groups](https://docs.nats.io/nats-concepts/core-nats/queue.md)
- [Queueing Walkthrough](https://docs.nats.io/nats-concepts/core-nats/queue/queues_walkthrough.md)
- [JetStream](https://docs.nats.io/nats-concepts/jetstream.md)
- [Streams](https://docs.nats.io/nats-concepts/jetstream/streams.md)
- [Source and Mirror Streams](https://docs.nats.io/nats-concepts/jetstream/source_and_mirror.md)
- [Example](https://docs.nats.io/nats-concepts/jetstream/source_and_mirror/source_and_mirror_example.md)
- [Consumers](https://docs.nats.io/nats-concepts/jetstream/consumers.md)
- [Example](https://docs.nats.io/nats-concepts/jetstream/consumers/example_configuration.md)
- [JetStream Walkthrough](https://docs.nats.io/nats-concepts/jetstream/js_walkthrough.md)
- [Key/Value Store](https://docs.nats.io/nats-concepts/jetstream/key-value-store.md)
- [Key/Value Store Walkthrough](https://docs.nats.io/nats-concepts/jetstream/key-value-store/kv_walkthrough.md)
- [Object Store](https://docs.nats.io/nats-concepts/jetstream/obj_store.md)
- [Object Store Walkthrough](https://docs.nats.io/nats-concepts/jetstream/obj_store/obj_walkthrough.md)
- [Headers](https://docs.nats.io/nats-concepts/jetstream/headers.md)
- [Subject Mapping and Partitioning](https://docs.nats.io/nats-concepts/subject_mapping.md)
- [NATS Service Infrastructure](https://docs.nats.io/nats-concepts/service_infrastructure.md)
- [NATS Adaptive Deployment Architectures](https://docs.nats.io/nats-concepts/service_infrastructure/adaptive_edge_deployment.md)
- [Security](https://docs.nats.io/nats-concepts/security.md)
- [Connectivity](https://docs.nats.io/nats-concepts/connectivity.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.nats.io/nats-concepts.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
